#ifndef __FLAGGER_MS_FILE_H__
#define __FLAGGER_MS_FILE_H__

#include <ms/MeasurementSets.h>
#include <vector>
#include <string>
#include <tables/Tables.h>

namespace WSRT
{
  class MS_File
  {
  public:
     MS_File(const std::string& msname);
    ~MS_File();

    int                     itsNumSamples;
    int                     itsNumAntennae;
    int                     itsNumFields;
    int                     itsNumBands;
    int                     itsNumChannels;
    int                     itsNumPolarizations;
    int                     itsNumPairs;
    int                     itsNumTimeslots;
    double                  itsNoiseLevel;
    std::vector<casa::String> itsAntennaNames;
    casa::Vector<casa::Int>   itsPolarizations;
    
    casa::TableIterator TimeslotIterator();
    casa::TableIterator TimeAntennaIterator();
    casa::MSAntenna     antenna();
    void                WriteDataPointFlags(casa::TableIterator* flag_iter, 
                                            casa::Matrix<casa::Bool>* Flags,
                                            bool FlagcompleteRow,
                                            bool ExistingFlags);
  
  protected:
    string                MSName;
    casa::MeasurementSet* MS;
    void init();
  private:
  }; // MS_File
}; // namespace WSRT

#endif // __FLAGGER_MS_FILE_H__
